"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_actions_1 = require("redux-actions");
var PENDING = '_ASYNC';
var FULFILLED = '_ASYNC_FULFILLED';
function createActionInner(type, payloadCreator, metaCreator) {
    return {
        pending: redux_actions_1.createAction(type + PENDING, payloadCreator, metaCreator),
        fulfilled: redux_actions_1.createAction(type + FULFILLED, payloadCreator, metaCreator),
    };
}
var actionMeta = '@redux-saga-action';
function createAction(type, payloadCreator) {
    return createActionInner(type, payloadCreator, function () { return actionMeta; });
}
exports.createAction = createAction;
function handleActions(reducerMap, defaultState, _actions) {
    if (_actions === void 0) { _actions = {}; }
    var reducer = function (state, action) {
        if (state === void 0) { state = defaultState; }
        if (typeof reducerMap[action.type] === 'function') {
            return reducerMap[action.type](state, action);
        }
        return state;
    };
    return reducer;
}
exports.handleActions = handleActions;
